#
# Copyright (c) 2002, Art Haas
#
#
# test segments
#

import unittest
import math
import random

import Generic.point as point
import Generic.segment as segment

def absdiff(testval, goodval):
    return abs(testval - goodval)

seed = 100
random.seed(seed)

class SegmentTestCase(unittest.TestCase):
    def setUp(self):
        self.p1 = point.Point(0,0)
        self.p2 = point.Point(10,0)
        self.p3 = point.Point(0,10)
        self.p4 = point.Point(-10,0)
        self.p5 = point.Point(0,-10)
        self.s1 = segment.Segment(self.p1,self.p2)
        self.s2 = segment.Segment(self.p1,self.p3)
        self.s3 = segment.Segment(self.p1,self.p4)
        self.s4 = segment.Segment(self.p1,self.p5)
        self.s5 = segment.Segment(self.p4,self.p2)
        self.s6 = segment.Segment(self.p5,self.p3)
        self.s7 = segment.Segment(self.p2,self.p4)
        self.s8 = segment.Segment(self.p3,self.p5)
        self.s9 = segment.Segment(self.p2,self.p3)
        self.s10 = segment.Segment(self.p3,self.p4)
        self.s11 = segment.Segment(self.p4,self.p5)
        self.s12 = segment.Segment(self.p5,self.p2)

    def testCreation(self):
        self.failUnless(self.s1.p1 is self.p1)
        self.failUnless(self.s1.p2 is self.p2)
        self.failUnless(self.s2.p1 is self.p1)
        self.failUnless(self.s2.p2 is self.p3)
        self.failUnless(self.s3.p1 is self.p1)
        self.failUnless(self.s3.p2 is self.p4)
        self.failUnless(self.s4.p1 is self.p1)
        self.failUnless(self.s4.p2 is self.p5)
        self.failUnless(self.s5.p1 is self.p4)
        self.failUnless(self.s5.p2 is self.p2)
        self.failUnless(self.s6.p1 is self.p5)
        self.failUnless(self.s6.p2 is self.p3)
        self.failUnless(self.s7.p1 is self.p2)
        self.failUnless(self.s7.p2 is self.p4)
        self.failUnless(self.s8.p1 is self.p3)
        self.failUnless(self.s8.p2 is self.p5)
        self.failUnless(self.s9.p1 is self.p2)
        self.failUnless(self.s9.p2 is self.p3)
        self.failUnless(self.s10.p1 is self.p3)
        self.failUnless(self.s10.p2 is self.p4)
        self.failUnless(self.s11.p1 is self.p4)
        self.failUnless(self.s11.p2 is self.p5)
        self.failUnless(self.s12.p1 is self.p5)
        self.failUnless(self.s12.p2 is self.p2)

    def testComparison(self):
        self.failUnless(self.s1 == self.s1)
        self.failUnless(self.s1 > self.s2 and self.s2 < self.s1)
        self.failUnless(self.s1 > self.s3 and self.s3 < self.s1)
        self.failUnless(self.s1 > self.s4 and self.s4 < self.s1)
        self.failUnless(self.s1 > self.s5 and self.s5 < self.s1)
        self.failUnless(self.s1 > self.s6 and self.s6 < self.s1)
        self.failUnless(self.s1 > self.s7 and self.s7 < self.s1)
        self.failUnless(self.s1 > self.s8 and self.s8 < self.s1)
        self.failUnless(self.s1 < self.s9 and self.s9 > self.s1)
        self.failUnless(self.s1 > self.s10 and self.s10 < self.s1)
        self.failUnless(self.s1 > self.s11 and self.s11 < self.s1)
        self.failUnless(self.s1 > self.s12 and self.s12 < self.s1)


        self.failUnless(self.s2 == self.s2)
        self.failUnless(self.s2 > self.s3 and self.s3 < self.s2)
        self.failUnless(self.s2 > self.s4 and self.s4 < self.s2)
        self.failUnless(self.s2 > self.s5 and self.s5 < self.s2)
        self.failUnless(self.s2 > self.s6 and self.s6 < self.s2)
        self.failUnless(self.s2 > self.s7 and self.s7 < self.s2)
        self.failUnless(self.s2 > self.s8 and self.s8 < self.s2)
        self.failUnless(self.s2 < self.s9 and self.s9 > self.s2)
        self.failUnless(self.s2 > self.s10 and self.s10 < self.s2)
        self.failUnless(self.s2 > self.s11 and self.s11 < self.s2)
        self.failUnless(self.s2 > self.s12 and self.s12 < self.s2)


        self.failUnless(self.s3 == self.s3)
        self.failUnless(self.s3 < self.s4 and self.s4 > self.s3)
        self.failUnless(self.s3 < self.s5 and self.s5 > self.s3)
        self.failUnless(self.s3 < self.s6 and self.s6 > self.s3)
        self.failUnless(self.s3 < self.s7 and self.s7 > self.s3)
        self.failUnless(self.s3 < self.s8 and self.s8 > self.s3)
        self.failUnless(self.s3 < self.s9 and self.s9 > self.s3)
        self.failUnless(self.s3 < self.s10 and self.s10 > self.s3)
        self.failUnless(self.s3 > self.s11 and self.s11 < self.s3)
        self.failUnless(self.s3 < self.s12 and self.s12 > self.s3)

        self.failUnless(self.s4 == self.s4)
        self.failUnless(self.s4 > self.s5 and self.s5 < self.s4)
        self.failUnless(self.s4 < self.s6 and self.s6 > self.s4)
        self.failUnless(self.s4 > self.s7 and self.s7 < self.s4)
        self.failUnless(self.s4 < self.s8 and self.s8 > self.s4)
        self.failUnless(self.s4 < self.s9 and self.s9 > self.s4)
        self.failUnless(self.s4 > self.s10 and self.s10 < self.s4)
        self.failUnless(self.s4 > self.s11 and self.s11 < self.s4)
        self.failUnless(self.s4 < self.s12 and self.s12 > self.s4)

        self.failUnless(self.s5 == self.s5)
        self.failUnless(self.s5 < self.s6 and self.s6 > self.s5)
        self.failUnless(self.s5 == self.s7 and self.s7 == self.s5)
        self.failUnless(self.s5 < self.s8 and self.s8 > self.s5)
        self.failUnless(self.s5 < self.s9 and self.s9 > self.s5)
        self.failUnless(self.s5 > self.s10 and self.s10 < self.s5)
        self.failUnless(self.s5 > self.s11 and self.s11 < self.s5)
        self.failUnless(self.s5 < self.s12 and self.s12 > self.s5)

        self.failUnless(self.s6 == self.s6)
        self.failUnless(self.s6 > self.s7 and self.s7 < self.s6)
        self.failUnless(self.s6 == self.s8 and self.s8 == self.s6)
        self.failUnless(self.s6 < self.s9 and self.s9 > self.s6)
        self.failUnless(self.s6 > self.s10 and self.s10 < self.s6)
        self.failUnless(self.s6 > self.s11 and self.s11 < self.s6)
        self.failUnless(self.s6 < self.s12 and self.s12 > self.s6)

        self.failUnless(self.s7 == self.s7)
        self.failUnless(self.s7 < self.s8 and self.s8 > self.s7)
        self.failUnless(self.s7 < self.s9 and self.s9 > self.s7)
        self.failUnless(self.s7 > self.s10 and self.s10 < self.s7)
        self.failUnless(self.s7 > self.s11 and self.s11 < self.s7)
        self.failUnless(self.s7 < self.s12 and self.s12 > self.s7)

        self.failUnless(self.s8 == self.s8)
        self.failUnless(self.s8 < self.s9 and self.s9 > self.s8)
        self.failUnless(self.s8 > self.s10 and self.s10 < self.s8)
        self.failUnless(self.s8 > self.s11 and self.s11 < self.s8)
        self.failUnless(self.s8 < self.s12 and self.s12 > self.s8)

        self.failUnless(self.s9 == self.s9)
        self.failUnless(self.s9 > self.s10 and self.s10 < self.s9)
        self.failUnless(self.s9 > self.s11 and self.s11 < self.s9)
        self.failUnless(self.s9 > self.s12 and self.s12 < self.s9)

        self.failUnless(self.s10 == self.s10)
        self.failUnless(self.s10 > self.s11 and self.s11 < self.s10)
        self.failUnless(self.s10 < self.s12 and self.s12 > self.s10)

        self.failUnless(self.s11 == self.s11)
        self.failUnless(self.s11 < self.s12 and self.s12 > self.s11)

        self.failUnless(self.s12 == self.s12)

        tp1 = point.Point(self.s1.p1.getCoords())
        tp2 = point.Point(self.s1.p2.getCoords())
        ts = segment.Segment(tp1,tp2)
        self.failUnless(ts == self.s1)


    def testPointMapping(self):
        p = self.s1.mapPoint(self.p1)
        self.failUnless(p == self.p1)
        p = self.s1.mapPoint(self.p2)
        self.failUnless(p == self.p2)
        p = self.s1.mapPoint(self.p3)
        self.failUnless(p is None)
        p = self.s1.mapPoint(self.p4)
        self.failUnless(p is None)
        p = self.s1.mapPoint(self.p5)
        self.failUnless(p is None)

        p = self.s1.mapPoint((0,0))
        self.failUnless(p == self.p1)
        p = self.s1.mapPoint((10,0))
        self.failUnless(p == self.p2)
        p = self.s1.mapPoint((0,10))
        self.failUnless(p is None)
        p = self.s1.mapPoint((-10,0))
        self.failUnless(p is None)
        p = self.s1.mapPoint((0,-10))
        self.failUnless(p is None)

        p = self.s1.mapPoint((-0.001,0))
        self.failUnless(p is None)
        p = self.s1.mapPoint((-0.001,0), 0.001)
        self.failUnless(p == (0,0))
        p = self.s1.mapPoint((10.001,0))
        self.failUnless(p is None)
        p = self.s1.mapPoint((10.001,0),0.001)
        self.failUnless(p == (10,0))
        p = self.s1.mapPoint((5,0.001))
        self.failUnless(p is None)
        p = self.s1.mapPoint((5,0.001),0.001)
        self.failUnless(p == (5,0))

    def testLength(self):
        self.failUnless(absdiff(self.s1.length(),10) < 1e-10)
        self.failUnless(absdiff(self.s2.length(),10) < 1e-10)
        self.failUnless(absdiff(self.s3.length(),10) < 1e-10)
        self.failUnless(absdiff(self.s4.length(),10) < 1e-10)
        self.failUnless(absdiff(self.s5.length(),20) < 1e-10)
        self.failUnless(absdiff(self.s6.length(),20) < 1e-10)
        self.failUnless(absdiff(self.s7.length(),20) < 1e-10)
        self.failUnless(absdiff(self.s8.length(),20) < 1e-10)
        slen = math.sqrt(2.0) * 10.0
        self.failUnless(absdiff(self.s9.length(),slen) < 1e-10)
        self.failUnless(absdiff(self.s10.length(),slen) < 1e-10)
        self.failUnless(absdiff(self.s11.length(),slen) < 1e-10)
        self.failUnless(absdiff(self.s12.length(),slen) < 1e-10)

class SegmentTreeTestCase(unittest.TestCase):
    def setUp(self):
        self.tree = segment.SegmentTree()
        self.p1 = point.Point(0,0)
        self.p2 = point.Point(10,0)
        self.p3 = point.Point(0,10)
        self.p4 = point.Point(-10,0)
        self.p5 = point.Point(0,-10)
        self.s1 = segment.Segment(self.p1,self.p2)
        self.s2 = segment.Segment(self.p1,self.p3)
        self.s3 = segment.Segment(self.p1,self.p4)
        self.s4 = segment.Segment(self.p1,self.p5)
        self.s5 = segment.Segment(self.p4,self.p2)
        self.s6 = segment.Segment(self.p5,self.p3)
        self.s7 = segment.Segment(self.p2,self.p4)
        self.s8 = segment.Segment(self.p3,self.p5)
        self.s9 = segment.Segment(self.p2,self.p3)
        self.s10 = segment.Segment(self.p3,self.p4)
        self.s11 = segment.Segment(self.p4,self.p5)
        self.s12 = segment.Segment(self.p5,self.p2)

    def testStorage(self):
        self.tree.store(self.s1)
        self.failUnless(len(self.tree) == 1)
        self.failUnless(self.s1 in self.tree)
        self.tree.store(self.s2)
        self.failUnless(len(self.tree) == 2)
        self.failUnless(self.s2 in self.tree)
        self.tree.store(self.s3)
        self.failUnless(len(self.tree) == 3)
        self.failUnless(self.s3 in self.tree)
        self.tree.store(self.s4)
        self.failUnless(len(self.tree) == 4)
        self.failUnless(self.s4 in self.tree)
        self.tree.store(self.s5)
        self.failUnless(len(self.tree) == 5)
        self.failUnless(self.s5 in self.tree)
        self.tree.store(self.s6)
        self.failUnless(len(self.tree) == 6)
        self.failUnless(self.s6 in self.tree)
        self.failUnless(self.s7 in self.tree) # same as self.s5
        self.failUnless(self.s8 in self.tree) # same as self.s6
        self.tree.store(self.s9)
        self.failUnless(len(self.tree) == 7)
        self.failUnless(self.s9 in self.tree)
        self.tree.store(self.s10)
        self.failUnless(len(self.tree) == 8)
        self.failUnless(self.s10 in self.tree)
        self.tree.store(self.s11)
        self.failUnless(len(self.tree) == 9)
        self.failUnless(self.s11 in self.tree)
        self.tree.store(self.s12)
        self.failUnless(len(self.tree) == 10)
        self.failUnless(self.s12 in self.tree)

        for i in xrange(1000):
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p1 = point.Point(x,y)
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p2 = point.Point(x,y)
            s = segment.Segment(p1, p2)
            self.tree.store(s)
        self.validateTree()

        for i in xrange(1000):
            x = -100.0 + (random.random() * 200.0)
            y = 0.0
            p1 = point.Point(x,y)
            x = -100.0 + (random.random() * 200.0)
            p2 = point.Point(x,y)
            s = segment.Segment(p1, p2)
            self.tree.store(s)
        self.validateTree()
        
        for i in xrange(1000):
            x = 0.0
            y = -100.0 + (random.random() * 200.0)
            p1 = point.Point(x,y)
            y = -100.0 + (random.random() * 200.0)
            p2 = point.Point(x,y)
            s = segment.Segment(p1, p2)
            self.tree.store(s)
        self.validateTree()

    def validateTree(self):
        for i in xrange(1, len(self.tree)):
            sp = self.tree[i-1]
            si = self.tree[i]
            sp_xmin = min(sp.p1.x, sp.p2.x)
            sp_ymin = min(sp.p1.y, sp.p2.y)
            sp_xmax = max(sp.p1.x, sp.p2.x)
            sp_ymax = max(sp.p1.y, sp.p2.y)
            si_xmin = min(si.p1.x, si.p2.x)
            si_ymin = min(si.p1.y, si.p2.y)
            si_xmax = max(si.p1.x, si.p2.x)
            si_ymax = max(si.p1.y, si.p2.y)
            self.failUnless(sp_xmin <= si_xmin)
            if abs(sp_xmin - si_xmin) < 1e-10:
                self.failUnless(sp_ymin <= si_ymin)
                if abs(sp_ymin - si_ymin) < 1e-10:
                    self.failUnless(sp_xmax <= si_xmax)                    
                    if abs(sp_xmax - si_xmax) < 1e-10:
                        self.failUnless(sp_ymax <= si_ymax)

    def testBinscan(self):
        self.tree.store(self.s1)
        self.tree.store(self.s2)
        self.tree.store(self.s3)
        self.tree.store(self.s4)
        self.tree.store(self.s5)
        self.tree.store(self.s6)
        self.tree.store(self.s9)
        self.tree.store(self.s10)
        self.tree.store(self.s11)
        self.tree.store(self.s12)
        st = self.tree.binscan(self.s1)
        self.failUnless(st is self.s1)
        st = self.tree.binscan(self.s2)
        self.failUnless(st is self.s2)
        st = self.tree.binscan(self.s3)
        self.failUnless(st is self.s3)
        st = self.tree.binscan(self.s4)
        self.failUnless(st is self.s4)
        st = self.tree.binscan(self.s5)
        self.failUnless(st is self.s5)
        st = self.tree.binscan(self.s6)
        self.failUnless(st is self.s6)
        st = self.tree.binscan(self.s7)
        self.failUnless(st == self.s7 and st is self.s5) # common endpoints
        st = self.tree.binscan(self.s8)
        self.failUnless(st == self.s8 and st is self.s6) # common endpoints
        st = self.tree.binscan(self.s9)
        self.failUnless(st is self.s9)
        st = self.tree.binscan(self.s10)
        self.failUnless(st is self.s10)
        st = self.tree.binscan(self.s11)
        self.failUnless(st is self.s11)
        st = self.tree.binscan(self.s12)
        self.failUnless(st is self.s12)

        rsegs = []
        for i in xrange(1000):
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p1 = point.Point(x,y)
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p2 = point.Point(x,y)
            s = segment.Segment(p1, p2)
            rsegs.append(s)
            self.tree.store(s)
        for i in xrange(len(rsegs)):
            rseg = rsegs[i]
            st = self.tree.binscan(rseg)
            self.failUnless(st is rseg)

    def testScan(self):
        self.tree.store(self.s1)
        self.tree.store(self.s2)
        self.tree.store(self.s3)
        self.tree.store(self.s4)
        self.tree.store(self.s5)
        self.tree.store(self.s6)
        self.tree.store(self.s9)
        self.tree.store(self.s10)
        self.tree.store(self.s11)
        self.tree.store(self.s12)
        st = self.tree.scan(self.s1)
        self.failUnless(st is self.s1)
        st = self.tree.scan(self.s2)
        self.failUnless(st is self.s2)
        st = self.tree.scan(self.s3)
        self.failUnless(st is self.s3)
        st = self.tree.scan(self.s4)
        self.failUnless(st is self.s4)
        st = self.tree.scan(self.s5)
        self.failUnless(st is self.s5)
        st = self.tree.scan(self.s6)
        self.failUnless(st is self.s6)
        st = self.tree.scan(self.s7)
        self.failUnless(st == self.s7 and st is self.s5) # common endpoints
        st = self.tree.scan(self.s8)
        self.failUnless(st == self.s8 and st is self.s6) # common endpoints
        st = self.tree.scan(self.s9)
        self.failUnless(st is self.s9)
        st = self.tree.scan(self.s10)
        self.failUnless(st is self.s10)
        st = self.tree.scan(self.s11)
        self.failUnless(st is self.s11)
        st = self.tree.scan(self.s12)
        self.failUnless(st is self.s12)

        rsegs = []
        for i in xrange(1000):
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p1 = point.Point(x,y)
            x = -100.0 + (random.random() * 200.0)
            y = -100.0 + (random.random() * 200.0)
            p2 = point.Point(x,y)
            s = segment.Segment(p1, p2)
            rsegs.append(s)
            self.tree.store(s)
        for i in xrange(len(rsegs)):
            rseg = rsegs[i]
            st = self.tree.scan(rseg)
            self.failUnless(st is rseg)

    def testRemove(self):
        self.tree.store(self.s1)
        self.tree.store(self.s2)
        self.tree.store(self.s3)
        self.tree.store(self.s4)
        self.tree.store(self.s5)
        self.tree.store(self.s6)
        self.tree.store(self.s9)
        self.tree.store(self.s10)
        self.tree.store(self.s11)
        self.tree.store(self.s12)
        self.tree.remove(self.s1)
        self.failUnless(len(self.tree) == 9)
        self.failIf(self.s1 in self.tree)
        self.tree.remove(self.s2)
        self.failUnless(len(self.tree) == 8)
        self.failIf(self.s2 in self.tree)
        self.tree.remove(self.s3)
        self.failUnless(len(self.tree) == 7)
        self.failIf(self.s3 in self.tree)
        self.tree.remove(self.s4)
        self.failUnless(len(self.tree) == 6)
        self.failIf(self.s4 in self.tree)
        self.tree.remove(self.s5)
        self.failUnless(len(self.tree) == 5)
        self.failIf(self.s5 in self.tree)
        self.failIf(self.s7 in self.tree)
        self.tree.remove(self.s6)
        self.failUnless(len(self.tree) == 4)
        self.failIf(self.s6 in self.tree)
        self.failIf(self.s8 in self.tree)
        self.tree.remove(self.s9)
        self.failUnless(len(self.tree) == 3)
        self.failIf(self.s9 in self.tree)
        self.tree.remove(self.s10)
        self.failUnless(len(self.tree) == 2)
        self.failIf(self.s10 in self.tree)
        self.tree.remove(self.s11)
        self.failUnless(len(self.tree) == 1)
        self.failIf(self.s11 in self.tree)
        self.tree.remove(self.s12)
        self.failIf(len(self.tree))
        self.failIf(self.s12 in self.tree)

    def testPointMapping(self):
        self.tree.store(self.s1)
        self.tree.store(self.s2)
        self.tree.store(self.s3)
        self.tree.store(self.s4)
        self.tree.store(self.s5)
        self.tree.store(self.s6)
        self.tree.store(self.s9)
        self.tree.store(self.s10)
        self.tree.store(self.s11)
        self.tree.store(self.s12)
        self.tree.remove(self.s1)
        hits = self.tree.mapPoint((0,0))
        self.failUnless(len(hits) == 2)
        self.failUnless(hits[0][1] == (0,0))
        self.failUnless(hits[1][1] == (0,0))
        hits = self.tree.mapPoint((5,5))
        self.failUnless(len(hits) == 1)
        self.failUnless(hits[0][0] is self.s9)
        self.failUnless(hits[0][1] == (5,5))
        hits = self.tree.mapPoint((5.001, 5.001))
        self.failIf(len(hits))
        hits = self.tree.mapPoint((5.001, 5.001), 0.001)
        self.failUnless(len(hits) == 1)
        self.failUnless(hits[0][0] is self.s9)
        self.failUnless(hits[0][1] == (5,5))
        hits = self.tree.mapPoint((4.999, 4.999))
        self.failIf(len(hits))
        hits = self.tree.mapPoint((4.999, 4.999), 0.001)
        self.failUnless(len(hits) == 1)
        self.failUnless(hits[0][0] is self.s9)
        self.failUnless(hits[0][1] == (5,5))


if __name__ == "__main__":
    SegmentTestSuite = unittest.TestSuite()
    SegmentTestSuite.addTest(SegmentTestCase("testCreation"))
    SegmentTestSuite.addTest(SegmentTestCase("testComparison"))
    SegmentTestSuite.addTest(SegmentTestCase("testPointMapping"))
    SegmentTestSuite.addTest(SegmentTestCase("testLength"))

    SegmentTreeTestSuite = unittest.TestSuite()
    SegmentTreeTestSuite.addTest(SegmentTreeTestCase("testStorage"))
    SegmentTreeTestSuite.addTest(SegmentTreeTestCase("testBinscan"))
    SegmentTreeTestSuite.addTest(SegmentTreeTestCase("testScan"))
    SegmentTreeTestSuite.addTest(SegmentTreeTestCase("testRemove"))
    SegmentTreeTestSuite.addTest(SegmentTreeTestCase("testPointMapping"))
    unittest.main()

